package org.appfuse.web;

import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.poi.hssf.usermodel.HSSFCell;
import org.apache.poi.hssf.usermodel.HSSFSheet;
import org.apache.poi.hssf.usermodel.HSSFWorkbook;
import org.appfuse.model.User;
import org.springframework.web.servlet.view.document.AbstractExcelView;

public class UserExcelView extends AbstractExcelView {
    
    protected void buildExcelDocument(Map model, HSSFWorkbook wb,
                                      HttpServletRequest req,
                                      HttpServletResponse resp)
    throws Exception {
        HSSFCell cell = null;
        
        HSSFSheet sheet = wb.createSheet("My Users");
        sheet.setDefaultColumnWidth((short) 12);

        // put text in first cell
        cell = getCell(sheet, 0, 0);
        setText(cell, "User List");

        List users = (List) model.get("users");

        for (int i = 0; i < users.size(); i++) {
            cell = getCell(sheet, 2 + i, 0);
            setText(cell, ((User) users.get(i)).getFullName());
        }
    }
}
