package org.appfuse.web;

import net.sourceforge.jwebunit.WebTestCase;

public class UserWebTest extends WebTestCase {
    
    public UserWebTest(String name) {
        super(name);
        getTestContext().setBaseUrl("http://localhost:8080/myusers");
        getTestContext().setAuthorization("admin", "admin");
    }
    
    public void testWelcomePage() {
        beginAt("/");
        assertTitleEquals("MyUsers ~ Welcome");
    }
    
    public void testAddUser() {
        beginAt("/editUser.html");
        assertTitleEquals("MyUsers ~ User Details");
        setFormElement("firstName", "Spring");
        setFormElement("lastName", "User");
        submit("save");
        assertTextPresent("saved successfully");
    }
    
    public void testListUsers() {
        beginAt("/users.html");     
        
        // check that table is present
        assertTablePresent("userList");

        //check that a set of strings are present somewhere in table
        assertTextInTable("userList",
                          new String[] {"Spring", "User"});
    }
    
    public void testEditUser() {
        beginAt("/editUser.html?id=" + getInsertedUserId());
        assertFormElementEquals("firstName", "Spring");
        submit("save");
        assertTitleEquals("MyUsers ~ User List");
    }
    
    public void testDeleteUser() {
        beginAt("/editUser.html?id=" + getInsertedUserId());
        assertTitleEquals("MyUsers ~ User Details");
        submit("delete");
        assertTitleEquals("MyUsers ~ User List");
    }
    
    /**
     * Convenience method to get the id of the inserted user
     * Assumes last user in table is "Spring User"
     */
    protected String getInsertedUserId() {
        beginAt("/users.html");
        assertTablePresent("userList");
        assertTextInTable("userList", "Spring");
        String[][] sparseTableCellValues =
                getDialog().getSparseTableBySummaryOrId("userList");
        return sparseTableCellValues[sparseTableCellValues.length-1][0];
    }
}