package org.appfuse.web;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import javax.xml.transform.Source;
import javax.xml.transform.dom.DOMSource;

import junit.framework.TestCase;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.appfuse.model.User;
import org.springframework.mock.web.MockHttpServletRequest;
import org.springframework.mock.web.MockHttpServletResponse;
import org.w3c.dom.Node;

public class UserXMLViewTest extends TestCase {
    private static Log log = LogFactory.getLog(UserXMLViewTest.class);
    
    public void testXMLCreation() throws Exception {
        // setup a user to print out as XML
        User user = new User();
        user.setFirstName("James");
        user.setLastName("Strachan");
        List users = new ArrayList();
        users.add(user);
        Map model = new HashMap();
        model.put("users", users);
        
        // invoke the XsltView and call its 'createDomNode' method
        UserXMLView feed = new UserXMLView();
        Source source = feed.createXsltSource(model, "users", 
                new MockHttpServletRequest(), 
                new MockHttpServletResponse());
        Node node = ((DOMSource) source).getNode();
        assertEquals(node.getFirstChild().toString(), 
                "<users><user>James Strachan</user></users>");
    }
}
